####################################################################
#
#    This file was generated using Parse::Yapp version 1.05.
#
#        Don't edit this file, use source file instead.
#
#             ANY CHANGE MADE HERE WILL BE LOST !
#
####################################################################
package Sitetool::Parse;
use vars qw ( @ISA );
use strict;

@ISA= qw ( Parse::Yapp::Driver );
#Included Parse/Yapp/Driver.pm file----------------------------------------
{
#
# Module Parse::Yapp::Driver
#
# This module is part of the Parse::Yapp package available on your
# nearest CPAN
#
# Any use of this module in a standalone parser make the included
# text under the same copyright as the Parse::Yapp module itself.
#
# This notice should remain unchanged.
#
# (c) Copyright 1998-2001 Francois Desarmenien, all rights reserved.
# (see the pod text in Parse::Yapp module for use and distribution rights)
#

package Parse::Yapp::Driver;

require 5.004;

use strict;

use vars qw ( $VERSION $COMPATIBLE $FILENAME );

$VERSION = '1.05';
$COMPATIBLE = '0.07';
$FILENAME=__FILE__;

use Carp;

#Known parameters, all starting with YY (leading YY will be discarded)
my(%params)=(YYLEX => 'CODE', 'YYERROR' => 'CODE', YYVERSION => '',
			 YYRULES => 'ARRAY', YYSTATES => 'ARRAY', YYDEBUG => '');
#Mandatory parameters
my(@params)=('LEX','RULES','STATES');

sub new {
    my($class)=shift;
	my($errst,$nberr,$token,$value,$check,$dotpos);
    my($self)={ ERROR => \&_Error,
				ERRST => \$errst,
                NBERR => \$nberr,
				TOKEN => \$token,
				VALUE => \$value,
				DOTPOS => \$dotpos,
				STACK => [],
				DEBUG => 0,
				CHECK => \$check };

	_CheckParams( [], \%params, \@_, $self );

		exists($$self{VERSION})
	and	$$self{VERSION} < $COMPATIBLE
	and	croak "Yapp driver version $VERSION ".
			  "incompatible with version $$self{VERSION}:\n".
			  "Please recompile parser module.";

        ref($class)
    and $class=ref($class);

    bless($self,$class);
}

sub YYParse {
    my($self)=shift;
    my($retval);

	_CheckParams( \@params, \%params, \@_, $self );

	if($$self{DEBUG}) {
		_DBLoad();
		$retval = eval '$self->_DBParse()';#Do not create stab entry on compile
        $@ and die $@;
	}
	else {
		$retval = $self->_Parse();
	}
    $retval
}

sub YYData {
	my($self)=shift;

		exists($$self{USER})
	or	$$self{USER}={};

	$$self{USER};
	
}

sub YYErrok {
	my($self)=shift;

	${$$self{ERRST}}=0;
    undef;
}

sub YYNberr {
	my($self)=shift;

	${$$self{NBERR}};
}

sub YYRecovering {
	my($self)=shift;

	${$$self{ERRST}} != 0;
}

sub YYAbort {
	my($self)=shift;

	${$$self{CHECK}}='ABORT';
    undef;
}

sub YYAccept {
	my($self)=shift;

	${$$self{CHECK}}='ACCEPT';
    undef;
}

sub YYError {
	my($self)=shift;

	${$$self{CHECK}}='ERROR';
    undef;
}

sub YYSemval {
	my($self)=shift;
	my($index)= $_[0] - ${$$self{DOTPOS}} - 1;

		$index < 0
	and	-$index <= @{$$self{STACK}}
	and	return $$self{STACK}[$index][1];

	undef;	#Invalid index
}

sub YYCurtok {
	my($self)=shift;

        @_
    and ${$$self{TOKEN}}=$_[0];
    ${$$self{TOKEN}};
}

sub YYCurval {
	my($self)=shift;

        @_
    and ${$$self{VALUE}}=$_[0];
    ${$$self{VALUE}};
}

sub YYExpect {
    my($self)=shift;

    keys %{$self->{STATES}[$self->{STACK}[-1][0]]{ACTIONS}}
}

sub YYLexer {
    my($self)=shift;

	$$self{LEX};
}


#################
# Private stuff #
#################


sub _CheckParams {
	my($mandatory,$checklist,$inarray,$outhash)=@_;
	my($prm,$value);
	my($prmlst)={};

	while(($prm,$value)=splice(@$inarray,0,2)) {
        $prm=uc($prm);
			exists($$checklist{$prm})
		or	croak("Unknow parameter '$prm'");
			ref($value) eq $$checklist{$prm}
		or	croak("Invalid value for parameter '$prm'");
        $prm=unpack('@2A*',$prm);
		$$outhash{$prm}=$value;
	}
	for (@$mandatory) {
			exists($$outhash{$_})
		or	croak("Missing mandatory parameter '".lc($_)."'");
	}
}

sub _Error {
	print "Parse error.\n";
}

sub _DBLoad {
	{
		no strict 'refs';

			exists(${__PACKAGE__.'::'}{_DBParse})#Already loaded ?
		and	return;
	}
	my($fname)=__FILE__;
	my(@drv);
	open(DRV,"<$fname") or die "Report this as a BUG: Cannot open $fname";
	while(<DRV>) {
                	/^\s*sub\s+_Parse\s*{\s*$/ .. /^\s*}\s*#\s*_Parse\s*$/
        	and     do {
                	s/^#DBG>//;
                	push(@drv,$_);
        	}
	}
	close(DRV);

	$drv[0]=~s/_P/_DBP/;
	eval join('',@drv);
}

#Note that for loading debugging version of the driver,
#this file will be parsed from 'sub _Parse' up to '}#_Parse' inclusive.
#So, DO NOT remove comment at end of sub !!!
sub _Parse {
    my($self)=shift;

	my($rules,$states,$lex,$error)
     = @$self{ 'RULES', 'STATES', 'LEX', 'ERROR' };
	my($errstatus,$nberror,$token,$value,$stack,$check,$dotpos)
     = @$self{ 'ERRST', 'NBERR', 'TOKEN', 'VALUE', 'STACK', 'CHECK', 'DOTPOS' };

#DBG>	my($debug)=$$self{DEBUG};
#DBG>	my($dbgerror)=0;

#DBG>	my($ShowCurToken) = sub {
#DBG>		my($tok)='>';
#DBG>		for (split('',$$token)) {
#DBG>			$tok.=		(ord($_) < 32 or ord($_) > 126)
#DBG>					?	sprintf('<%02X>',ord($_))
#DBG>					:	$_;
#DBG>		}
#DBG>		$tok.='<';
#DBG>	};

	$$errstatus=0;
	$$nberror=0;
	($$token,$$value)=(undef,undef);
	@$stack=( [ 0, undef ] );
	$$check='';

    while(1) {
        my($actions,$act,$stateno);

        $stateno=$$stack[-1][0];
        $actions=$$states[$stateno];

#DBG>	print STDERR ('-' x 40),"\n";
#DBG>		$debug & 0x2
#DBG>	and	print STDERR "In state $stateno:\n";
#DBG>		$debug & 0x08
#DBG>	and	print STDERR "Stack:[".
#DBG>					 join(',',map { $$_[0] } @$stack).
#DBG>					 "]\n";


        if  (exists($$actions{ACTIONS})) {

				defined($$token)
            or	do {
				($$token,$$value)=&$lex($self);
#DBG>				$debug & 0x01
#DBG>			and	print STDERR "Need token. Got ".&$ShowCurToken."\n";
			};

            $act=   exists($$actions{ACTIONS}{$$token})
                    ?   $$actions{ACTIONS}{$$token}
                    :   exists($$actions{DEFAULT})
                        ?   $$actions{DEFAULT}
                        :   undef;
        }
        else {
            $act=$$actions{DEFAULT};
#DBG>			$debug & 0x01
#DBG>		and	print STDERR "Don't need token.\n";
        }

            defined($act)
        and do {

                $act > 0
            and do {        #shift

#DBG>				$debug & 0x04
#DBG>			and	print STDERR "Shift and go to state $act.\n";

					$$errstatus
				and	do {
					--$$errstatus;

#DBG>					$debug & 0x10
#DBG>				and	$dbgerror
#DBG>				and	$$errstatus == 0
#DBG>				and	do {
#DBG>					print STDERR "**End of Error recovery.\n";
#DBG>					$dbgerror=0;
#DBG>				};
				};


                push(@$stack,[ $act, $$value ]);

					$$token ne ''	#Don't eat the eof
				and	$$token=$$value=undef;
                next;
            };

            #reduce
            my($lhs,$len,$code,@sempar,$semval);
            ($lhs,$len,$code)=@{$$rules[-$act]};

#DBG>			$debug & 0x04
#DBG>		and	$act
#DBG>		and	print STDERR "Reduce using rule ".-$act." ($lhs,$len): ";

                $act
            or  $self->YYAccept();

            $$dotpos=$len;

                unpack('A1',$lhs) eq '@'    #In line rule
            and do {
                    $lhs =~ /^\@[0-9]+\-([0-9]+)$/
                or  die "In line rule name '$lhs' ill formed: ".
                        "report it as a BUG.\n";
                $$dotpos = $1;
            };

            @sempar =       $$dotpos
                        ?   map { $$_[1] } @$stack[ -$$dotpos .. -1 ]
                        :   ();

            $semval = $code ? &$code( $self, @sempar )
                            : @sempar ? $sempar[0] : undef;

            splice(@$stack,-$len,$len);

                $$check eq 'ACCEPT'
            and do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Accept.\n";

				return($semval);
			};

                $$check eq 'ABORT'
            and	do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Abort.\n";

				return(undef);

			};

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Back to state $$stack[-1][0], then ";

                $$check eq 'ERROR'
            or  do {
#DBG>				$debug & 0x04
#DBG>			and	print STDERR 
#DBG>				    "go to state $$states[$$stack[-1][0]]{GOTOS}{$lhs}.\n";

#DBG>				$debug & 0x10
#DBG>			and	$dbgerror
#DBG>			and	$$errstatus == 0
#DBG>			and	do {
#DBG>				print STDERR "**End of Error recovery.\n";
#DBG>				$dbgerror=0;
#DBG>			};

			    push(@$stack,
                     [ $$states[$$stack[-1][0]]{GOTOS}{$lhs}, $semval ]);
                $$check='';
                next;
            };

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Forced Error recovery.\n";

            $$check='';

        };

        #Error
            $$errstatus
        or   do {

            $$errstatus = 1;
            &$error($self);
                $$errstatus # if 0, then YYErrok has been called
            or  next;       # so continue parsing

#DBG>			$debug & 0x10
#DBG>		and	do {
#DBG>			print STDERR "**Entering Error recovery.\n";
#DBG>			++$dbgerror;
#DBG>		};

            ++$$nberror;

        };

			$$errstatus == 3	#The next token is not valid: discard it
		and	do {
				$$token eq ''	# End of input: no hope
			and	do {
#DBG>				$debug & 0x10
#DBG>			and	print STDERR "**At eof: aborting.\n";
				return(undef);
			};

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Dicard invalid token ".&$ShowCurToken.".\n";

			$$token=$$value=undef;
		};

        $$errstatus=3;

		while(	  @$stack
			  and (		not exists($$states[$$stack[-1][0]]{ACTIONS})
			        or  not exists($$states[$$stack[-1][0]]{ACTIONS}{error})
					or	$$states[$$stack[-1][0]]{ACTIONS}{error} <= 0)) {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Pop state $$stack[-1][0].\n";

			pop(@$stack);
		}

			@$stack
		or	do {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**No state left on stack: aborting.\n";

			return(undef);
		};

		#shift the error token

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Shift \$error token and go to state ".
#DBG>						 $$states[$$stack[-1][0]]{ACTIONS}{error}.
#DBG>						 ".\n";

		push(@$stack, [ $$states[$$stack[-1][0]]{ACTIONS}{error}, undef ]);

    }

    #never reached
	croak("Error in driver logic. Please, report it as a BUG");

}#_Parse
#DO NOT remove comment

1;

}
#End of include--------------------------------------------------


#line 1 "./Parse.yp"

#
# Parse.pm
#
# Copyright (C) 2008, 2009 Francesco Salvestrini
#                          Alessandro Massignan
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#

    use 5.8.0;

    use warnings;
    use strict;
    use diagnostics;

    use Sitetool::Autoconfig;
    use Sitetool::Base::Trace;
    use Sitetool::Base::Debug;
    use Sitetool::OS::Shell;
    use Sitetool::OS::File;
    use Sitetool::OS::Filename;

    BEGIN {
	use Exporter ();
	our ($VERSION, @ISA, @EXPORT);

	@ISA    = qw(Exporter);
	@EXPORT = qw(&parse);
    }

    my $parsed_string   = "";
    my $indentation     = "";
    my $container_start = 0;
    my $container_type  = "GROUP";
    my $output_handler  = "";
    my $file_name       = undef;
    my $line_number     = 0;
    my $o_curly         = '{';
    my $c_curly         = '}';


    

sub new {
        my($class)=shift;
        ref($class)
    and $class=ref($class);

    my($self)=$class->SUPER::new( yyversion => '1.05',
                                  yystates =>
[
	{#State 0
		ACTIONS => {
			'AUTOGEN' => 1
		},
		GOTOS => {
			'syntax' => 2,
			'header' => 3
		}
	},
	{#State 1
		ACTIONS => {
			'DEFINITIONS' => 4
		}
	},
	{#State 2
		ACTIONS => {
			'' => 5
		}
	},
	{#State 3
		ACTIONS => {
			'SYMBOL' => 7
		},
		DEFAULT => -3,
		GOTOS => {
			'body' => 6,
			'main_groups' => 9,
			'main_group' => 8
		}
	},
	{#State 4
		ACTIONS => {
			'SYMBOL' => 10
		}
	},
	{#State 5
		DEFAULT => 0
	},
	{#State 6
		DEFAULT => -1
	},
	{#State 7
		ACTIONS => {
			"=" => 11
		}
	},
	{#State 8
		ACTIONS => {
			'SYMBOL' => 7
		},
		DEFAULT => -5,
		GOTOS => {
			'main_groups' => 12,
			'main_group' => 8
		}
	},
	{#State 9
		DEFAULT => -4
	},
	{#State 10
		ACTIONS => {
			";" => 13
		}
	},
	{#State 11
		ACTIONS => {
			"{" => 14
		}
	},
	{#State 12
		DEFAULT => -6
	},
	{#State 13
		DEFAULT => -2
	},
	{#State 14
		DEFAULT => -7,
		GOTOS => {
			'@1-3' => 15
		}
	},
	{#State 15
		ACTIONS => {
			'SYMBOL' => 16,
			'sub_indexed' => 19
		},
		GOTOS => {
			'sub_variable' => 18,
			'sub_group' => 17,
			'main_group_item' => 20,
			'main_group_items' => 21
		}
	},
	{#State 16
		ACTIONS => {
			"=" => 22
		}
	},
	{#State 17
		DEFAULT => -12
	},
	{#State 18
		DEFAULT => -11
	},
	{#State 19
		DEFAULT => -13
	},
	{#State 20
		ACTIONS => {
			'SYMBOL' => 16,
			'sub_indexed' => 19
		},
		DEFAULT => -9,
		GOTOS => {
			'sub_variable' => 18,
			'sub_group' => 17,
			'main_group_item' => 20,
			'main_group_items' => 23
		}
	},
	{#State 21
		ACTIONS => {
			"}" => 24
		}
	},
	{#State 22
		ACTIONS => {
			"{" => 25,
			'QUOTEDSTRING' => 26
		}
	},
	{#State 23
		DEFAULT => -10
	},
	{#State 24
		ACTIONS => {
			";" => 27
		}
	},
	{#State 25
		ACTIONS => {
			"id" => 28
		},
		GOTOS => {
			'sub_group_id' => 29
		}
	},
	{#State 26
		ACTIONS => {
			";" => 30
		}
	},
	{#State 27
		DEFAULT => -8
	},
	{#State 28
		ACTIONS => {
			"=" => 31
		}
	},
	{#State 29
		ACTIONS => {
			'SYMBOL' => 33
		},
		GOTOS => {
			'sub_group_item' => 32,
			'sub_variable' => 35,
			'sub_container' => 34,
			'sub_group_items' => 36
		}
	},
	{#State 30
		DEFAULT => -14
	},
	{#State 31
		ACTIONS => {
			'QUOTEDSTRING' => 37
		}
	},
	{#State 32
		ACTIONS => {
			'SYMBOL' => 33
		},
		DEFAULT => -17,
		GOTOS => {
			'sub_group_item' => 32,
			'sub_variable' => 35,
			'sub_container' => 34,
			'sub_group_items' => 38
		}
	},
	{#State 33
		ACTIONS => {
			"=" => 39
		}
	},
	{#State 34
		DEFAULT => -20
	},
	{#State 35
		DEFAULT => -19
	},
	{#State 36
		ACTIONS => {
			"}" => 40
		}
	},
	{#State 37
		ACTIONS => {
			";" => 41
		}
	},
	{#State 38
		DEFAULT => -18
	},
	{#State 39
		ACTIONS => {
			"{" => 42,
			'QUOTEDSTRING' => 26
		}
	},
	{#State 40
		ACTIONS => {
			";" => 43
		}
	},
	{#State 41
		DEFAULT => -16
	},
	{#State 42
		DEFAULT => -21,
		GOTOS => {
			'@2-3' => 44
		}
	},
	{#State 43
		DEFAULT => -15
	},
	{#State 44
		ACTIONS => {
			'SYMBOL' => 46
		},
		GOTOS => {
			'sub_container_items' => 45,
			'sub_group_item' => 32,
			'sub_indexed_items' => 48,
			'sub_container' => 34,
			'sub_variable' => 35,
			'sub_group_items' => 49,
			'sub_indexed_item' => 47
		}
	},
	{#State 45
		ACTIONS => {
			"}" => 50
		}
	},
	{#State 46
		ACTIONS => {
			"[" => 51,
			"=" => 39
		}
	},
	{#State 47
		ACTIONS => {
			'SYMBOL' => 52
		},
		DEFAULT => -25,
		GOTOS => {
			'sub_indexed_items' => 53,
			'sub_indexed_item' => 47
		}
	},
	{#State 48
		DEFAULT => -23
	},
	{#State 49
		DEFAULT => -24
	},
	{#State 50
		ACTIONS => {
			";" => 54
		}
	},
	{#State 51
		ACTIONS => {
			'DECIMAL' => 55
		}
	},
	{#State 52
		ACTIONS => {
			"[" => 51
		}
	},
	{#State 53
		DEFAULT => -26
	},
	{#State 54
		DEFAULT => -22
	},
	{#State 55
		ACTIONS => {
			"]" => 56
		}
	},
	{#State 56
		ACTIONS => {
			"=" => 57
		}
	},
	{#State 57
		ACTIONS => {
			"{" => 58
		}
	},
	{#State 58
		DEFAULT => -27,
		GOTOS => {
			'@3-6' => 59
		}
	},
	{#State 59
		ACTIONS => {
			'SYMBOL' => 33
		},
		GOTOS => {
			'sub_group_item' => 32,
			'sub_variable' => 35,
			'sub_container' => 34,
			'sub_group_items' => 60
		}
	},
	{#State 60
		ACTIONS => {
			"}" => 61
		}
	},
	{#State 61
		ACTIONS => {
			";" => 62
		}
	},
	{#State 62
		DEFAULT => -28
	}
],
                                  yyrules  =>
[
	[#Rule 0
		 '$start', 2, undef
	],
	[#Rule 1
		 'syntax', 2, undef
	],
	[#Rule 2
		 'header', 4, undef
	],
	[#Rule 3
		 'body', 0, undef
	],
	[#Rule 4
		 'body', 1, undef
	],
	[#Rule 5
		 'main_groups', 1, undef
	],
	[#Rule 6
		 'main_groups', 2, undef
	],
	[#Rule 7
		 '@1-3', 0,
sub
#line 71 "./Parse.yp"
{

    $_[1] =~ y/[a-z]/[A-Z]/;

    $parsed_string .= $indentation .
	"\'"         .
	$_[1]        .
	"\' => "     .
	$o_curly     .
	"\n";

    $indentation .= "\t";

}
	],
	[#Rule 8
		 'main_group', 7,
sub
#line 84 "./Parse.yp"
{

    $indentation =~ s/.//;

    $parsed_string .= $c_curly . ",\n";

}
	],
	[#Rule 9
		 'main_group_items', 1, undef
	],
	[#Rule 10
		 'main_group_items', 2, undef
	],
	[#Rule 11
		 'main_group_item', 1, undef
	],
	[#Rule 12
		 'main_group_item', 1, undef
	],
	[#Rule 13
		 'main_group_item', 1, undef
	],
	[#Rule 14
		 'sub_variable', 4,
sub
#line 99 "./Parse.yp"
{

    if ($container_start == 1) {
	$container_start = 0;
	$container_type  = 'GROUP';

	$parsed_string .= $o_curly . "\n";
    }

    $_[1] =~ y/[a-z]/[A-Z]/;
    $_[1] =~ s/^VAR\-//;

    $parsed_string .= $indentation .
	"\'"         .
	$_[1]        .
	"\' => \""   .
	$_[3]        .
	"\",\n";

}
	],
	[#Rule 15
		 'sub_group', 7,
sub
#line 121 "./Parse.yp"
{

    $indentation =~ s/.//;

    $parsed_string .= $indentation . $c_curly . ",\n";

}
	],
	[#Rule 16
		 'sub_group_id', 4,
sub
#line 130 "./Parse.yp"
{

    $parsed_string .= $indentation .
	"\'"         .
	$_[3]        .
	"\' => "     .
	$o_curly     .
	"\n";

    $indentation .= "\t";

}
	],
	[#Rule 17
		 'sub_group_items', 1, undef
	],
	[#Rule 18
		 'sub_group_items', 2, undef
	],
	[#Rule 19
		 'sub_group_item', 1, undef
	],
	[#Rule 20
		 'sub_group_item', 1, undef
	],
	[#Rule 21
		 '@2-3', 0,
sub
#line 149 "./Parse.yp"
{

    $_[1] =~ y/[a-z]/[A-Z]/;

    $parsed_string .= $indentation . "\'" . $_[1] . "\' => ";

    $container_start = 1;

    $indentation .= "\t";

}
	],
	[#Rule 22
		 'sub_container', 7,
sub
#line 159 "./Parse.yp"
{

    $indentation =~ s/.//;

    if ($container_type eq 'GROUP') {
	$parsed_string .= $indentation . $c_curly . ",\n";
    } else {
	$parsed_string .= $indentation . "],\n";
    }

}
	],
	[#Rule 23
		 'sub_container_items', 1, undef
	],
	[#Rule 24
		 'sub_container_items', 1, undef
	],
	[#Rule 25
		 'sub_indexed_items', 1, undef
	],
	[#Rule 26
		 'sub_indexed_items', 2, undef
	],
	[#Rule 27
		 '@3-6', 0,
sub
#line 178 "./Parse.yp"
{

    if ($container_start == 1) {
	$container_start = 0;
	$container_type  = 'INDEXED';

	$parsed_string .= "[\n";

    }
    $parsed_string .= $indentation . $o_curly . "\n";

    $indentation .= "\t";

}
	],
	[#Rule 28
		 'sub_indexed_item', 10,
sub
#line 191 "./Parse.yp"
{

    $indentation =~ s/.//;

    $parsed_string .= $indentation . $c_curly . ",\n";

}
	]
],
                                  @_);
    bless($self,$class);
}

#line 200 "./Parse.yp"


sub lexer_callback
{
    my $parser = shift;

    assert(defined($parser));
    assert(defined($parser->YYData->{INPUT}));

    while (length($parser->YYData->{INPUT}) >= 0) {
	debug("Parsing " . $file_name . ":" . $line_number . " "  .
	      "(" . length($parser->YYData->{INPUT}) . " to go)");

	# Remove leading whitespaces
	$parser->YYData->{INPUT} =~ s/^[ \t]+//;

	if ($parser->YYData->{INPUT} =~ s/^\n//) {

	    debug("Eating newline");
	    $line_number++;

	} elsif ($parser->YYData->{INPUT} =~
		 s/^\/\/.*\n//) {

	    debug("Eating comment and newline");
	    $line_number++;

	} elsif ($parser->YYData->{INPUT} =~
		 s/^id[ \t]*//) {

	    debug("Got id");

	    return ("id", "id");

	} elsif ($parser->YYData->{INPUT} =~
		 s/^autogen[ \t]*//) {

	    debug("Got autogen keyword");

	    return ("AUTOGEN", undef);

	} elsif ($parser->YYData->{INPUT} =~
		 s/^definitions[ \t]*//) {

	    debug("Got definitions keyword");

	    return ("DEFINITIONS", undef);

	} elsif ($parser->YYData->{INPUT} =~
		 s/^\#[ \t]*line[ \t]+([0-9]+)[ \t]*//) {

	    debug("Got line \`" . $1 . "' directive");
	    $line_number = $1;

	} elsif ($parser->YYData->{INPUT} =~
		 s/^\#[ \t]*file[ \t]+\"(.*)"[ \t]*//) {

	    debug("Got file \`" . $1 . "' directive");
	    $file_name = $1;

	} elsif ($parser->YYData->{INPUT} =~
		 s/^([a-zA-Z_][a-zA-Z0-9_\-]*)[ \t]*//) {

	    debug("Got symbol \`" . $1 . "'");

	    return ("SYMBOL", $1);

	} elsif ($parser->YYData->{INPUT} =~
		 s/^([0-9]+)[ \t]*//) {

	    debug("Got decimal");

	    return ("DECIMAL", $1);

	} elsif ($parser->YYData->{INPUT} =~
		 s/^\"(.*)\"[ \t]*//) {

	    debug("Got quoted string \`" . $1 . "'");

	    return ("QUOTEDSTRING", $1);

	} elsif ($parser->YYData->{INPUT} =~
		 s/^([\{\}\[\]\;\=])[ \t]*//) {

	    debug("Got punctuation \`" . $1 . "'");

	    return ($1, $1);

	} elsif ($parser->YYData->{INPUT} =~
		 s/^(.)//) {

	    debug("Got character \`" . $1 . "'");

	    return ($1, $1);

	} elsif ($parser->YYData->{INPUT} =~
		 s/^$//) {

	    debug("Got END-OF-FILE");

	    return ('', undef);

	} else {
	    bug("Undefined lexer input `" .
		substr($parser->YYData->{INPUT}, 0, 1)     .
		"\'");
	}
    }

    bug("Unreachable code");
}

sub syntax_error
{
    my $message = shift;
    my $lineno  = shift;

    assert(defined($message));
    assert(defined($lineno));

    error("Syntax error at line " . $lineno . ": " . $message);
    exit 1;
}

sub error_callback
{
    my $parser = shift;

    assert(defined($parser));

    my $value = $parser->YYCurtok;
    assert(defined($value));

    error("Unexpected \`" . $value . "'");
}

sub parse ($$)
{
    my $input_filename = shift;
    my $string_ref     = shift;

    assert(defined($input_filename));
    assert(defined($string_ref));

    debug("Parsing file \`" . $input_filename . "'");

    if (!file_ispresent($input_filename)) {
	error("Input file \`" . $input_filename . "' is missing");
	return 0;
    }

    my $string = "";
    if (!file_tostring($input_filename, \$string)) {
	return 0;
    }

    # Setup useful variables used later on
    $file_name   = $input_filename;
    $line_number = 1;

    my $parser;
    $parser = Sitetool::Parse->new();
    assert(defined($parser));

    $parser->YYData->{INPUT} = $string;

    my $debug_level;
#    $debug_level = debug_get() ? 0x1F : 0x00);
    $debug_level = 0;

    my $result;
    $result = $parser->YYParse(yylex   => \&lexer_callback,
			       yyerror => \&error_callback,
			       yydebug => $debug_level);

    if ($parser->YYNberr() > 0) {
	error("Cannot parse input file \`" . $input_filename . "'");
	return 0;
    }

    debug("Parsing completed successfully");

    ${$string_ref} = $parsed_string;

    return 1;
}

1;
